%define _unpackaged_files_terminate_build 0

Name:			perl-XML-Pastor
Version:		1.0.3
Release:		1%{?dist}
Summary:		Generate Perl classes with XML bindings starting from a W3C XSD Schema
License:		GPL+ or Artistic
Group:			Development/Libraries
URL:			http://search.cpan.org/dist/XML-Pastor/
Source0:		http://www.cpan.org/modules/by-module/XML/XML-Pastor-%{version}.tar.gz
Patch0:			XML-Pastor-Builtin.patch
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:		noarch
BuildRequires:	perl(Class::Accessor)
BuildRequires:	perl(Class::Data::Inheritable)
BuildRequires:	perl(Data::HashArray)
BuildRequires:	perl(File::chdir)
BuildRequires:	perl(LWP::UserAgent)
BuildRequires:	perl(Test::Simple)
BuildRequires:	perl(URI)
BuildRequires:	perl(XML::LibXML) >= 1.66
BuildRequires:	perl(ExtUtils::MakeMaker)
Requires:		perl(Class::Accessor)
Requires:		perl(Class::Data::Inheritable)
Requires:		perl(Data::HashArray)
Requires:		perl(File::chdir)
Requires:		perl(LWP::UserAgent)
Requires:		perl(URI)
Requires:		perl(XML::LibXML) >= 1.66
Requires:		perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description
Java had CASTOR, and now Perl has XML::Pastor!

If you know what Castor does in the Java world, then XML::Pastor should be
familiar to you. If you have a W3C XSD schema, you can generate Perl classes
with roundtrip XML bindings.

Whereas Castor is limited to offline code generation, XML::Pastor is able to
generate Perl classes either offline or at run-time starting from a W3C XSD
Schema. The generated classes correspond to the global elements, complex and
simple type declarations in the schema. The generated classes have full XML
binding, meaning objects belonging to them can be read from and written to XML.
Accessor methods for attributes and child elements will be generated
automatically. Furthermore it is possible to validate the objects of generated
classes against the original schema although the schema is typically no longer
accessible.

XML::Pastor defines just one method, 'generate()', but the classes it generates
define many methods which may be found in the documentation of
XML::Pastor::ComplexType and XML::Pastor::SimpleType from which all generated
classes descend.

In 'offline' mode, it is possible to generate a single module with all the
generated classes or multiple modules one for each class. The typical use of
the offline mode is during a 'make' process, where you have a set of XSD
schemas and you generate your modules to be later installed by the
'make install'. This is very similar to Java Castor's behavior. This way your
XSD schemas don't have to be accessible during run-time and you don't have a
performance penalty.

Perl philosophy dictates however, that There Is More Than One Way To Do It.
In 'eval' (run-time) mode, the XSD schema is processed at run-time giving much
more flexibility to the user. This added flexibility has a price on the other
hand, namely a performance penalty and the fact that the XSD schema needs to be
accessible at run-time. Note that the performance penalty applies only to the
code generation (pastorize) phase; the generated classes perform the same as if
they were generated offline.

There is a command line utility called pastorize that can help generating
classes offline. See the documentation of pastorize for more details on that.

%prep
%setup -q -n XML-Pastor-%{version}
%patch0 -p1

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{perl_vendorlib}/*
%{_mandir}/man3/*

%changelog
* Sun Jun 17 2012 asides@lbl.gov 1.0.3-1
- Specfile autogenerated by cpanspec 1.77.
